const { SlashCommandBuilder, EmbedBuilder } = require("discord.js");
const { __glob } = require("../modules/global-variables");
const { LogType } = require('./sub-log');

const dlog = new LogType("Queue-List")

var next = new Array()
var previous = new Array()
var current = null;

module.exports.List = class {

    constructor() { 
        
    }

    getList() {

        return next
    }

    destroy() {

        next = new Array()
        previous = new Array()
        current = null
    }

    next() {
        const song = next[0]
        next.splice(0, 1)
        return song
    }

    previous() {

        const song = previous[0]
        previous.splice(0, 1)
        return song

    }

    setCurrent(song) {

        current = song.queue.current
  
    }

    passCurrent() {

        previous.unshift(current)
 
    }

    haveSongs() {

        if(next.length == 0) {
            return false

        } else{
            return true
        }
        
    }

    havePreviousSongs() {

        if(previous.length == 0) {
            return false

        } else{
            return true
        }
        
    }

    getNextSong() {

        const song = next[0]
        return song
       
    }


    async add(song, interaction) {
        
        dlog.log("Ajout d'un titre dans la liste de lecture : '" + song.title + "' de '" + song.author + "'")
        next.push(song)

        if(interaction) {

            const embed = await new EmbedBuilder()
            .setColor(0x15e6ed)
            .setTitle('**Ajout dans la liste de lecture **: ' + song.title)
            .setDescription('**Demandé par **' + interaction.member.user.username)
            .addFields({name: "Auteur", value: song.author},
                       {name: "URL", value: song.uri})
            .setThumbnail(song.thumbnail)
            .setTimestamp();

            interaction.reply({embeds: [embed]})
        }
    }

    remove(song) {
        
        dlog.log("Supression d'un titre dans la liste de lecture : '" + song.title + "' de '" + song.author + "'")
        
        const index = next.indexOf(song)
        next.splice(index, 1)

    }

    __previous_add(song) {

        previous.unshift(song)

    }

    __previous_remove(song) {

        const index = next.indexOf(song)
        previous.splice(index, 1)
    }

    __next_add(song) {

        next.unshift(song)

    }

    async playlistAdd(playlist, interaction) {

        if(interaction) {

            const client = interaction.client

            var author = "Artiste inconnu !"

                if(typeof playlist.author != "undefined" ) {

                    author == playlist.author.name
                }


            const embed = await new EmbedBuilder()
            .setColor(0x15e6ed)
            .setTitle('**Lecture de la playlist : **' + playlist.title)
            .setDescription('**Demandé par **' + interaction.member.user.username)
            .addFields({name: "Auteur", value: author},
                      {name: "URL", value:playlist.url},
                      {name: "Nombre de videos", value:playlist.video_count + " vidéos"})
            .setThumbnail(playlist.thumbnail_url)
            .setTimestamp();

            interaction.reply({embeds: [embed]})

            let player = client.manager.players.get(interaction.guild.id)

            for(var song of playlist.videos) {
        
                const song_finded = await client.manager.search(song.url)
                next.push(song_finded.tracks[0])

            }

            if(!player.playing) {

               player.play(next[0])
               this.remove(next[0])
            
            }

           

        } else {

            // [A FINIR POUR WEB]
        }

        



    } 

}