const userInfoDiv = document.getElementById("userInfo")
const userInfoPopup = document.getElementById("userPopup")
const userInfoglobal = document.getElementById("userInfoglobal")

const musicTitle = document.getElementById("music_title")
const musicURL = document.getElementById("music_img")

const durationBar = document.getElementById("duration")
const durationTextAct = document.getElementById("durationTextAct")
const durationTextTotal = document.getElementById("durationTextTotal")

const backward = document.getElementById("backward")
const play = document.getElementById("play")
const forward = document.getElementById("forward")

const settings_dialog = document.getElementById("SETTINGS_dialog")
const settings_close = document.getElementById("SETTINGS_close")
const settingsBtn = document.getElementById("settingsBtn")

const SPECIAL = document.getElementById("SPECIAL")

const loop = document.getElementById("loop")
const vol = document.getElementById("vol")
const shuffle = document.getElementById("shuffle")
const list = document.getElementById("list")

const volBox = document.getElementById("volumeBox")
const volTxt = document.getElementById("volumeTxt")
const volDiv = document.getElementById("volDiv")
const volRange = document.getElementById("volumeInput")

const disconnect = document.getElementById("disconnect")

const userInfo = get("USER_INFO")

volBox.classList.add("invisible")

vol.addEventListener("click", () => {

    if(volBox.classList.contains('invisible')) {
        volBox.classList.remove("invisible")
      
    } else {

        volBox.classList.add("invisible")
    }
 
})

volRange.addEventListener("click", () => {

    send("VOLUME", volRange.value)
})



disconnect.addEventListener("click", () => {

    get("DISCONNECT")
})

SPECIAL.addEventListener("click", () => {
    
    get("SPECIAL/MJ")

})

/*settingsBtn.addEventListener("click", () => {

    settings_dialog.showModal()
})*/

loop.addEventListener("click", () => {

    get("LOOP")
})


settings_close.addEventListener("click",() => {

    settings_dialog.close()
})

var durationAll = 0
var durationProgress = 0
var isPlaying = false
let interval;

durationBar.addEventListener("change", () => {

    send("SEEK", durationBar.value)

})


userInfo.then(user => {

    var betastar = ""
    
    if(user.beta) {

        betastar = "<p class='beta'>BETA</p>"
    }

    userInfoDiv.innerHTML = "<div class='INDEX_userInfo_name'><p class='INDEX_gbname'>" + user.user.global_name + "</p><p class='INDEX_usrname'>" + user.user.username + "</p></div><div class='INDEX_picture'><img src='https://cdn.discordapp.com/avatars/" + user.user.id + "/" + user.user.avatar + "'>" + betastar + "</div>"
})

userInfoDiv.addEventListener("click", () => {

    
    userInfoPopup.classList.add("INDEX_userPopup_Visible")
    userInfoPopup.classList.remove("INDEX_userPopup")
})

userInfoglobal.addEventListener("mouseleave", () => {

    userInfoPopup.classList.add("INDEX_userPopup")
    userInfoPopup.classList.remove("INDEX_userPopup_Visible")
})

get("MUSIC_STATE").then(data => {
    console.log(data)
})

play.addEventListener('click', () => {

    get("PAUSE")
})

backward.addEventListener('click', () => {

    get("BACKWARD")
})


forward.addEventListener("click", () => {

    get("FORWARD")
})

socket.on("/ALWAYS/MUSIC_STATE", (data) => {


    stopInterval()
    console.log(data)

    durationAll = 0
    durationProgress = 0
    isPlaying = false

    if(data.isOnline) {
        loop.classList.remove("disabled")
        vol.classList.remove("disabled")
        shuffle.classList.remove("disabled")
        list.classList.remove("disabled")
        play.classList.remove("pri_disable")
        disconnect.classList.remove("invisible")
        volRange.classList.add("disabled")
        volRange.disabled = false
    } else {
        loop.classList.add("disabled")
        vol.classList.add("disabled")
        shuffle.classList.add("disabled")
        list.classList.add("disabled")
        play.classList.add("pri_disable")
        disconnect.classList.add("invisible")
        volRange.classList.add("disabled")
        volRange.disabled = true
        volRange.value = 0
        volTxt.innerHTML = "0%"
        volBox.classList.add("invisible")
    }

    if(data.volume) {
        volRange.step = 1
        volRange.max = 200
        volRange.min = 1
        volRange.value = Math.trunc(data.volume / 10)
        volTxt.innerHTML = Math.trunc(data.volume / 10) + "%"

    } else {

        volRange.classList.add("disabled")
        volRange.disabled = true
        volRange.value = 0
        volTxt.innerHTML = "0%"
    }

    if(data.loop == true) {
        loop.innerHTML = '<i class="third-join fa fa-retweet"></i>'

    } else {

        loop.innerHTML = '<i class="fa fa-retweet"></i>'
    }

    if(data.current == null) {

        musicURL.innerHTML = '<img class="showPicture" src="images/black-image.svg">'
        musicTitle.innerHTML = "<p>Aucun titre joué</p>"
    } else {

        musicURL.innerHTML = '<img class="showPicture" src="' + data.current.thumbnail + '">'
        musicTitle.innerHTML = "<p>" + data.current.title + "</p>"
    }

    if(data.durationAll) {
        durationBar.disabled = false
        durationBar.classList.remove("grised")
        setTime()
       
        durationAll = data.durationAll
        durationProgress = data.durationNow
        durationBar.value = durationProgress
        setTime()

    } else {

       
        isPlaying = false
        durationAll = 0
        durationProgress = 0
        durationBar.disabled = true
        durationBar.classList.add("grised")
        durationBar.value = 0
        durationTextAct.innerHTML = "-:--"
        durationTextTotal.innerHTML = "-:--"
        
    }


    if(data.playing == 1) {
        play.innerHTML = '<i class="fas fa-pause"></i>'
        isPlaying = true
        startInterval()
    } else {
        
        play.innerHTML = '<i class="fas fa-play"></i>'
        isPlaying = false
       
    }

   
  
    if(data.current && data.playing == 0) {
        setTime()

    }





})

function startInterval() {
    interval = setInterval(() => {


        if(isPlaying == true) {
            setTime()
    
        } 
    
    }, 1000)

}

function stopInterval() {
    clearInterval(interval);
}
  





function setTime() {


    durationBar.max = durationAll
    durationProgress += 1000 
    durationBar.value = durationProgress

    
    const maxhours = Math.floor(durationAll / 3600000);
    const nowhours = Math.floor(durationProgress / 3600000);

    

    var maxmin = Math.trunc(durationAll / 60000) - (Math.floor(durationAll / 60000 / 60) * 60);
    var maxsec = Math.floor(durationAll / 1000) - (Math.floor(durationAll / 1000 / 60) * 60);
    var nowmin = Math.trunc(durationProgress / 60000) - (Math.floor(durationProgress / 60000 / 60) * 60);
    var nowsec = Math.floor(durationProgress / 1000) - (Math.floor(durationProgress / 1000 / 60) * 60);

    console.log(durationAll)
    console.log(durationProgress)
    console.log("---------------------")

    var now = ""
    var max = ""


    if (maxmin < 10) {
        maxmin = `0${maxmin}`;
    }

    if (nowmin < 10) {
        nowmin = `0${nowmin}`;
    }

    if (maxsec < 10) {
        maxsec = `0${maxsec}`;
    }

    if (nowsec < 10) {
        nowsec = `0${nowsec}`;
    }

    if(maxhours != 0) {
       
        max =  maxhours + ":" + maxmin + ":" + maxsec
    } else {
        max =  maxmin + ":" + maxsec
       
    }

    if(nowhours != 0) {
       
        now =  nowhours + ":" + nowmin + ":" + nowsec
    } else {
        now =  nowmin + ":" + nowsec
       
    }

    

   durationTextAct.innerHTML = now
   durationTextTotal.innerHTML = max
}